<?php 
/*
Fast Logs 1.0 - A fast, free and easy application for logging and displaying updates, 
notices or similar (C) 2010 Beverley Hooton (author website - http://fast-apps.co.uk/)

    Fast Note is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

include('fast_logs_config.php');
include('fast_logs_functions.php');


if($_SESSION['flusername']) 
	{

	if (!isset($_GET['page']))
		{
		header("Location: index.php?page=1"); // counteracts bug where WYSIWYG toolbar wont load without "page" query string
		}

	$_SESSION['editfile'] = isset($_GET['editfile']) ? $_GET['editfile'] : '';
	$action_edit = isset($_GET['action_edit']) ? $_GET['action_edit'] : '';
	$editfile = isset($_GET['editfile']) ? $_GET['editfile'] : '';
	$_SESSION['page'] = isset($_GET['page']) ? $_GET['page'] : '';

	$contentpage_edit = $entry_root.$editfile;
	$data = @file_get_contents($contentpage_edit); // populate fast-note textarea with entry.txt page

	$dir = opendir($entry_root);
	$page_array = array(); // (re)set this as empty 
	while (false !== ($page = readdir($dir)))
		{
		if ( ($page!='..') && ($page!='.') ) // add files to exclude from entry list as required
			{
            		$page_array[] = $entry_root.$page;
			} 	
		}

	if ( (isset($_GET['action'])) && ($_GET['action']=='save') ) // save changes
		{
		$editfile = $_POST['editfile'];
		$content = $entry_root.$editfile;
		if ( fileAllowed($entry_root, $editfile) ) {
			$data = $_POST['fastlogs'];
			$fp = fopen($content,'w');
			$data = stripslashes($data);
			$data = preg_replace(array('/<(\?|\%)\=?(php)?/', '/(\%|\?)>/'), array('',''), $data); // remove old-asp tags, php short-tags, php echo tags, and normal php tags
			$data = strip_onlyfl($data, $strip_tags); // strip_only function - replace tags + attributes but leaves contents
			if ($style_attr == '0') 
				{
				$data = preg_replace('/(<[^>]+) style=".*?"/i', '$1', $data); // remove style attribute from tags
				}
			fwrite($fp,$data);
			fclose($fp);
			}
		header("Location: index.php?action_edit=edit&editfile=".$editfile."&page=".$_SESSION['page'] );
		exit();
		}

	if ( (isset($_GET['action'])) && ($_GET['action']=='create') ) // create new entry
		{
		$entry_title = date('Y_m_d_H_i').'_'.time(true);
		$base_file = $entry_root.$entry_title.'.txt'; 
		$create_base_file = fopen($base_file, 'w+');
		$chmod = chmod($base_file, 0755);
		fwrite($create_base_file, "<p>Type your entry text here</p>");
		fclose($create_base_file); 
		header("Location: index.php?action_edit=edit&editfile=".$entry_title.".txt&page=1" );
		exit();
		}

	if ( (isset($_GET['action'])) && ($_GET['action']=='inactive') ) // hide entry
		{
		$inactivefile = $_GET['inactivefile'];
		$fp = fopen($entry_status.$inactivefile, 'w');
		fwrite($fp, "inactive");
		fclose($fp);
		header("Location: index.php?page=".$_SESSION['page']);
		exit();
		}

	if ( (isset($_GET['action'])) && ($_GET['action']=='active') ) // show entry
		{
		$activefile = $_GET['activefile'];
		unlink($entry_status.$activefile); 
		header("Location: index.php?page=".$_SESSION['page']);
		exit();
		}

	if ( (isset($_GET['action'])) && ($_GET['action']=='delete') ) // delete entry
		{
		$delfile = $_GET['delfile']; 
		if ( fileAllowed($entry_root, $delfile) ) {
			unlink($entry_root.$delfile);
			@unlink($entry_status.$delfile);
			}
		header("Location: index.php?page=".$_SESSION['page']);
		exit();
		}

	if ( (isset($_GET['action'])) && ($_GET['action']=='search') ) // search (IE10+ formaction="?action=search&page=1")
		{
		$search = trim($_POST['search']);
		foreach ($page_array as $page) {
			$content_entry = file_get_contents($page);
			$segment = explode("||", $content_entry);
			$news_entry = $segment[0];
			if (stripos($news_entry, $search) !== false) {
            			$search_array[] = $page;
				}
			}
		if (!empty($search_array)) { 
			$page_array = $search_array; 
			$per_page = 1000;
			}
		}
		?>



<div class="fast-logs-container">

	<form id="formeditor1" name="formeditor1" method="post" action="<?php echo $_SERVER['PHP_SELF'];?>?action=save">
			Welcome back <?php echo $_SESSION['flusername'];?> 
		<div class="fast-logs-headings">
			New&nbsp;Log&nbsp;Entry:&nbsp;<a href="?action=create"><img src="fast_logs/images/page_add.png" alt="New Log Entry" title="New Log Entry" class="create"/></a> &nbsp;&nbsp;|&nbsp;&nbsp;
			Start&nbsp;Screen: <a href="index.php"><img src="fast_logs/images/refresh.png" alt="Start Screen" title="Start Screen" class="logout" /></a> &nbsp;&nbsp;|&nbsp;&nbsp; 
			<input type="text" name="search" value="Search..." class="field" onfocus="clearText(this)" onblur="clearText(this)" /><input type="submit" style="padding:1px 6px" value="Go" onclick="document.getElementById('formeditor1').action='<?php echo $_SERVER['PHP_SELF'];?>?action=search&page=1'" /> &nbsp;&nbsp;|&nbsp;&nbsp; 
			Logout&nbsp;<?php echo $_SESSION['flusername'];?>:&nbsp;<a href="?action=logout"><img src="fast_logs/images/lock_open.png" alt="Logout <?php echo $_SESSION['flusername'];?>" title="Logout <?php echo $_SESSION['flusername'];?>" class="logout" /></a>
		</div>	
		<?php echo "<input type='hidden' id='editfile' name='editfile' value='$editfile' />";?>
		<div class="editor">
			<textarea name="fastlogs" cols="80" rows="10">
				<?php 
				if (!isset($_GET['action_edit'])) 
					{
					echo "To <b>create</b> a new entry, click the 'New Log Entry' icon above (on the right): <img src='fast_logs/images/page_add.png'><br/><br/>"; 
					echo "To <b>edit</b> an existing entry, click the 'Edit Entry' icon from the entry list below (on the right): <img src='fast_logs/images/page_edit.png'><br/><br/>";
					echo "To <b>delete</b> an old entry, click the 'Delete Entry' icon from the entry list below (on the right): <img src='fast_logs/images/cross.png'>";
					} 
					else 
					{ 
					echo $data; 
					} 
					?>
			</textarea> 
		</div>
	</form>




	<div class="entry-manager-container">

<?php 

	if (!empty($search_array)) 
		{
		echo '<span class="heading">Search Results&nbsp; ('.count($search_array).' matches found)</span>';
		} 
		else 
		{
		if ( $entry_sort == '0') 
			{ 
			echo '<span class="heading">Log Entry Manager&nbsp; (sorted oldest to newest - oldest on top)</span>';
			} 
			else 
			{
			echo '<span class="heading">Log Entry Manager&nbsp; (sorted newest to oldest - newest on top)</span>';
			}
		}
		?>

	<br style="clear:both;"/>

<?php 

	echo "<table id='page-list' class='tablesorter'><thead>\n<tr><th class='left entry-text'><a href='' title='Click to Sort'>Log Entry Text</a></th><th><a href='' title='Click to Sort'>Entry<br/>Status</a></th><th><a href='' title='Click to Sort'>Date<br/>Created</a></th><th><a href='' title='Click to Sort'>Edit<br/>Entry</a></th><th><a href='' title='Click to Sort'>Last<br/>Edited</a></th><th><a href='' title='Click to Sort'>Delete<br/>Entry</a></th></tr>\n</thead><tbody>\n";

		if ($entry_sort == 0 ) 
			{
			sort ($page_array); // sort pages a-z (oldest on top)
			}
			else
			{
			rsort ($page_array); // sort pages z-a (newest on top)
			}
   
		$file_count = count($page_array);
		$page_count = ceil( $file_count / $per_page );
		$page = ( isset($_GET['page']) && is_numeric($_GET['page']) ) ? (int) $_GET['page'] : 1;
		if( $page > $page_count )
    			{
       		 	$page = $page_count;
    			}
		if( $page < 1 )
    			{
        		$page = 1;
    			}

		$total_on_page = $per_page - ( ( $page * $per_page ) - $file_count );   
		$offset = ( ( $page - 1 ) * $per_page );   
		if ( $total_on_page < $per_page ) 
			{
			$per_page = $total_on_page;
			}

		if ( $pagination == 0 || $pagination == 2 )
			{
			showPaginationfl($page,$page_count,$range); // show pagination
			}
   
		for ( $i = $offset; $i < ( $offset + $per_page ); $i++ )
    			{

			$content_entry = file_get_contents($page_array[$i]);
			$contentpage_current = $page_array[$i];
			$entry = str_replace($entry_root, '', $page_array[$i]);
			$name = str_replace($entry_root, '', substr($page_array[$i],0,strrpos($page_array[$i],'.')) );
			$created = explode("_", $name);

			$year = substr($created[0], -2); 
			$day = $created[2];
			$month = date('M', strtotime($day.'-'.$created[1].'-'.$year));
			$min = $created[4];
			$hour = date('h', strtotime($created[3].':'.$created[4]));
			$ampm = date('a', strtotime($created[3].':'.$created[4]));

			$lastup = filemtime($contentpage_current);

			$current_time = date("h:ia", (filemtime($contentpage_current)));
			$current_date = date("d-M-y", (filemtime($contentpage_current)));

			$estatus_file = $entry_status.$entry;
			$estatus = @file_get_contents($estatus_file);

			$red = "<a href='".$_SERVER['PHP_SELF']."?action=active&activefile=$entry&page=$page' title='Inactive (click to activate)'><img src='fast_logs/images/inactive.png' alt='Inactive (click to activate)' class='hidden'/></a>";
			$green = "<a href='".$_SERVER['PHP_SELF']."?action=inactive&inactivefile=$entry&page=$page' title='Active (click to deactivate)'><img src='fast_logs/images/active.png' alt='Active (click to deactivate)' class='visible'/></a>";

			if ( $estatus == 'inactive' )
				{ 
				$status = $red; 
				}
				else
				{
				$status = $green; 
				}

			$entry_length = strlen(strip_tags($content_entry));
			if ($entry_length < ($excerpt)) 
				{
				echo "<tr><td class='left' width='100%'>$content_entry";
				} 
				else 
				{
             			echo '<tr><td class="left" width="100%">'.substrwsfl(strip_tags($content_entry, '<p>'), $excerpt, 0).'<p><a href="javascript:void(0);" onclick="ReadMore(\''.$created[5].'\'); this.innerHTML=(this.innerHTML==\'Read More &#9660;\')?\'Read Less &#9650;\':\'Read More &#9660;\';">Read More &#9660;</a></p><div id="'.$created[5].'" style="display:none;">'.substrwsfl($content_entry, 999999, 0).'</div>';
				}
			echo "</td><td>$status</td><td class='width'><span class='mini'>$created[5]</span>$day-$month-$year<br/>$hour:$min$ampm</td><td><a href='".$_SERVER['PHP_SELF']."?action_edit=edit&editfile=$entry&page=$page' title='Edit Log Entry'><img src='fast_logs/images/page_edit.png' alt='Edit Log Entry' class='edit'/></a></td><td class='width'><span class='mini'>$lastup</span>$current_date<br/>$current_time</td><td><a href='javascript:confirmDelete(\"".$_SERVER['PHP_SELF']."?action=delete&delfile=$entry&page=$page\")' title='Delete Log Entry'><img src='fast_logs/images/cross.png' alt='Delete Log Entry' class='delete'/></a></td></tr>\n";
    			}

		echo "</tbody></table>\n";

		if ( $pagination == 1 || $pagination == 2 )
			{
			showPaginationfl($page,$page_count,$range); // show pagination
			}

		?>

</div>

<?php } ?>

