<?php
/*
Fast Logs 1.0 - A fast, free and easy application for logging and displaying updates, 
notices or similar (C) 2010 Beverley Hooton (author website - http://fast-apps.co.uk/)

    Fast Note is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/


// pagination
function showPaginationfl($page,$page_count,$range) {
	echo '<div class="pagination_admin pagination">';
	echo 'Page(s): ';

	if ( $page > 1 )
    		{
       		 echo '<a href="?page=1" title="First" class="button">&lt;&lt;</a> <a href="?page='.( $page - 1 ).'" title="Previous" class="button">&lt;</a> | ';
    		}

	for ( $num = ($page - $range); $num < ( ($page + $range) + 1); $num++ )
    		{
        	if( $num > 0 && $num <= $page_count )
        		{
            		if( $num == $page )
            			{
                		echo ' <span class="number">'.$num.'</span> | ';
            			}
            			else
            			{
                		echo ' <a href="?page='.$num.'">'.$num.'</a> | ';
            			}
        		}
   		 }

	if ( $page != $page_count )
    		{
        	echo ' <a href="?page='.( $page + 1 ).'" title="Next" class="button">&gt;</a> <a href="?page='.$page_count.'" title="Last" class="button">&gt;&gt;</a> ';
    		}
	echo '</div>';
}


// word-sensitive substring function with html tags awareness // http://ellislab.com/forums/viewthread/160280/#771886 
function substrwsfl($text, $len, $start) { // $text = text to cut, $len = max length of cut string, $start = where to begin cut
    $raw_text_length = strlen($text);          
    
    if ($raw_text_length < $len + $start) // remaining text is less then max length
        $len = $raw_text_length;     
          
    if ($start - $len >= 0 || $len == $raw_text_length) // check if white space before
        $prev_whitespace_pos = strpos($text, "<p>", $start);
    else
        $prev_whitespace_pos = 0;
       
    if ($len + $start > $raw_text_length) // check if white space after
        $next_whitespace_pos = $raw_text_length;
    else
        $next_whitespace_pos = strpos($text, "<p>", $len + $start);
    if ($next_whitespace_pos === FALSE)
        $next_whitespace_pos = $len + $start;
        
    $text = substr($text, $prev_whitespace_pos, $next_whitespace_pos - $prev_whitespace_pos); 
    $text2 = 0;   
    
    if (preg_match_all("|<([a-zA-Z]+)>|",$text,$aBuffer)) // close unclosed html tags
    {
        if (!empty($aBuffer[1]))
        {
            preg_match_all("|</([a-zA-Z]+)>|",$text,$aBuffer2);

            if (count($aBuffer[1]) != count($aBuffer2[1]))
            {
                foreach ($aBuffer[1] as $index => $tag)
                {
                    if( empty($aBuffer2[1][$index]) || $aBuffer2[1][$index] != $tag)
                        $text .= ' ... </'.$tag.'>';
                }
            }
        }
    }
    return $text;
}


function strip_onlyfl($str, $tags, $stripContent = false) { 
    $content = ''; 
    if(!is_array($tags)) { 
        $tags = (strpos($str, '>') !== false ? explode('>', str_replace('<', '', $tags)) : array($tags)); 
        if(end($tags) == '') array_pop($tags); 
    } 
    foreach($tags as $tag) { 
        if ($stripContent) 
             $content = '(.+</'.$tag.'[^>]*>|)'; 
         $str = preg_replace('#</?'.$tag.'[^>]*>'.$content.'#is', '', $str); 
    } 
    return $str; 
} 
//$str = '<font color="red">red</font> text'; 
//$tags = 'font'; 
//$a = strip_onlyfl($str, $tags); // strips html tags + attributes but leaves contents - result: "red text" 
//$b = strip_onlyfl($str, $tags, true); // strips html tags + attrubutes + contents - result: "text"


function normalizePath($path) {
	$parts = array();// Array to build a new path from the good parts
	$path = str_replace('\\', '/', $path);// Replace backslashes with forwardslashes
	$path = preg_replace('/\/+/', '/', $path);// Combine multiple slashes into a single slash
	$segments = explode('/', $path);// Collect path segments
	$test = '';// Initialize testing variable
	foreach ($segments as $segment) {
        	if ($segment != '.') {
			$test = array_pop($parts);
			if (is_null($test)) { $parts[] = $segment; }
            		else if($segment == '..') {
				if ($test == '..') { $parts[] = $test; }
				if ($test == '..' || $test == '') { $parts[] = $segment; }
			} else {
				$parts[] = $test;
				$parts[] = $segment;
				}
			}
		}
	return implode('/', $parts);
	}


function fileAllowed($root, $file) {
	$rpath = normalizePath(realpath($root.$file));
	$root = normalizePath($root);
	if (strpos($rpath, $root) === 0) { // Check that $rpath is within allowed directory
		if ( file_exists($root.$file) && strpos($root.$file, '.txt',1) ) {
			return true;
			}
		}
	}

?>