<?php 
/*
Fast Logs 1.0 - A fast, free and easy application for logging and displaying updates, 
notices or similar (C) 2010 Beverley Hooton (author website - http://fast-apps.co.uk/)

    Fast Note is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

ob_start();
require('fast_logs/fast_logs_login.php');
?>


<!DOCTYPE html>
<html lang="en">
<head>
<meta charset="utf-8" />


<title>Fast Logs Administration : <?php echo $website_title ;?></title>
<link rel="stylesheet" href="fast_logs/styles/fast_logs.css" />
<!--[if IE]><link rel="stylesheet" href="fast_logs/styles/fast_logs_ie.css" /><![endif]-->
<script src="fast_logs/tinymce/tinymce/jscripts/tiny_mce/tiny_mce.js"></script>
<script src="fast_logs/js/jquery-1.4.2.min.js"></script>
<script src="fast_logs/js/jquery.tablesorter.js"></script> 
<?php if(isset($_SESSION['flusername'])) { ?>
<script>
	tinyMCE.init({
		mode : "exact",
		elements : "fastlogs",
		width : "100%",
		height : "150",
		theme : "advanced",
		plugins : "save",
		convert_urls : false,
		theme_advanced_buttons1 : "save,|,bold,italic,underline,|,justifyleft,justifycenter,justifyright,|,bullist,numlist,|,undo,redo,|,link,unlink,anchor,|,code",
		theme_advanced_buttons2 : "",
		theme_advanced_buttons3 : "",
		theme_advanced_buttons4 : "",
		theme_advanced_statusbar_location : "none",
		theme_advanced_toolbar_location : "top",
		theme_advanced_toolbar_align : "center",
		save_onsavecallback : "Editor_Save"
		});

function Editor_Save() {
    document.formeditor1.action = "?action=save&page=<?php echo $_SESSION['page'] ?>";
    document.formeditor1.submit();
};

function confirmDelete(delUrl) {
  if (confirm("Are you sure you want to delete this entry?")) {
    document.location = delUrl;
  }
}

function clearText(field){
    if (field.defaultValue == field.value) field.value = '';
    else if (field.value == '') field.value = field.defaultValue; 
}

function ReadMore(id) {
	var e = document.getElementById(id);
	e.style.display = ((e.style.display!='none')?'none':'block');
}

<?php if ( $entry_sort == '0') { ?>
$(document).ready(function() {
	$("#page-list").tablesorter( {sortList: [[2,0]]} ) // sort on the 3rd column, order ascending
});
<?php } else { ?>
$(document).ready(function() {
	$("#page-list").tablesorter( {sortList: [[2,1]]} ) // sort on the 3rd column, order descending
});
<?php } ?>
</script> 
<?php } ?>

</head> 
<body>

<h2 style="text-align:center;">Fast Logs Administration : <?php echo $website_title ;?></h2>

<div class="fast-logs-outer">

<?php if(isset($_SESSION['flusername'])) 
	{
	include('fast_logs/fast_logs_admin.php');
	}
	else
	{
	?>
<div class="fast-logs-container">
	<p style="text-align:center">Sorry, you do not have permission to access this area. Please login.</p>
	<?php if (isset($login_error)) { echo $login_error; } ?>
	</br>
	<div class="login-box-outer">
		Admin Login: <img src="fast_logs/images/lock.png" alt="Admin Login"/>
		<div class="login-box">
			<form method="post" action="<?php echo $_SERVER['PHP_SELF'];?>?action=login">
			Username:<br/><input type="text" name="name" size="15" style="margin:2px auto;"/><br/>
			Password:<br/><input type="password" name="pass" size="15" style="margin:2px auto;"/><br/>
			<input type="image" src="fast_logs/images/login.gif" name="submit_login" alt="Login" title="Login" class="login-submit"/>
			</form>
		</div>
	</div>
</div>
<?php } ?>

<div class="last-updated examples">
	<b>Fast Logs as they could be installed on a website:</b> <a href="example.php" target="_blank" class="link">Sample</a>
</div>

<div class="last-updated" style="text-align:center;">
	<p>Copyright &copy; 2010-<?php echo date('Y')?> Beverley Hooton &mdash; <a href="http://fast-apps.co.uk/" target="_blank" title="Visit the Fast Apps website" class="link">Fast Apps</a></p>
</div>

</div>

</body>
</html>